VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "L33t Chat - Robert Schatz"
   ClientHeight    =   4545
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9450
   LinkTopic       =   "Form1"
   ScaleHeight     =   4545
   ScaleWidth      =   9450
   Begin VB.CheckBox chkAuthorize 
      Caption         =   "   Authorize Connections"
      Height          =   345
      Left            =   90
      TabIndex        =   13
      Top             =   3540
      Width           =   1275
   End
   Begin VB.TextBox txtNickname 
      Height          =   285
      Left            =   90
      TabIndex        =   11
      Top             =   3090
      Width           =   1335
   End
   Begin VB.ListBox lstNames 
      Height          =   3855
      IntegralHeight  =   0   'False
      Left            =   7650
      Sorted          =   -1  'True
      TabIndex        =   10
      ToolTipText     =   "Right click to Copy IP Address or Kick"
      Top             =   270
      Width           =   1785
   End
   Begin VB.CommandButton cmdClear 
      Caption         =   "Clear"
      Height          =   315
      Left            =   7920
      TabIndex        =   9
      Top             =   4200
      Width           =   1215
   End
   Begin VB.TextBox txtLocalIP 
      Height          =   285
      Left            =   90
      Locked          =   -1  'True
      TabIndex        =   7
      Top             =   2490
      Width           =   1335
   End
   Begin VB.TextBox txtRemoteHost 
      Height          =   285
      Left            =   90
      TabIndex        =   0
      Top             =   450
      Width           =   1335
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close"
      Enabled         =   0   'False
      Height          =   375
      Left            =   90
      TabIndex        =   5
      Top             =   1800
      Width           =   1335
   End
   Begin VB.CommandButton cmdConnect 
      Caption         =   "Connect"
      Height          =   375
      Left            =   90
      TabIndex        =   4
      Top             =   840
      Width           =   1335
   End
   Begin VB.CommandButton cmdHost 
      Caption         =   "Host"
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   1320
      Width           =   1335
   End
   Begin VB.TextBox txtTalk 
      Height          =   285
      Left            =   1560
      Locked          =   -1  'True
      TabIndex        =   2
      Top             =   4200
      Width           =   6015
   End
   Begin VB.TextBox txtChat 
      Height          =   3855
      Left            =   1560
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      Top             =   270
      Width           =   6015
   End
   Begin VB.Label lblNickname 
      Alignment       =   2  'Center
      Caption         =   "Nickname"
      Height          =   255
      Left            =   90
      TabIndex        =   12
      Top             =   2880
      Width           =   1335
   End
   Begin VB.Label lblLocalIP 
      Alignment       =   2  'Center
      Caption         =   "Local IP"
      Height          =   255
      Left            =   90
      TabIndex        =   8
      Top             =   2280
      Width           =   1335
   End
   Begin VB.Label lblRemoteHost 
      Alignment       =   2  'Center
      Caption         =   "Remote Host"
      Height          =   255
      Left            =   90
      TabIndex        =   6
      Top             =   240
      Width           =   1335
   End
   Begin VB.Menu mnuNicknames 
      Caption         =   "Nicknames"
      Visible         =   0   'False
      Begin VB.Menu mnuCopyIP 
         Caption         =   "Copy IP"
      End
      Begin VB.Menu mnuKick 
         Caption         =   "Kick"
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' *********************************************************
' READ THIS NOW:
' Things you should know:
' to use a specific ip or port for listening or connecting, just set the LocalIP and/or LocalPort properties
' GetService function retrieves the corresponding name or number for a service:
' ie:
' Socket.GetService("TCP", "FTP") returns 21
' Socket.GetService(6, 21) returns "ftp"
' Socket.GetService("TCP", 21) returns "ftp"
' Socket.GetService(6, "ftp") returns 21
' GetProtocol function retrieves the corresponding name or number for a protocol:
' ie:
' Socket.GetProtocol("tcp") returns 6
' Socket.GetProtocol(6) returns "tcp"
' these values are retrieved from the SERVICES file in your windows directory
' demonstration of GetIPs and GetHosts functions are in Form_Load event
' for UDP, set Protocol property to sockUDP
' there is no bind method, set LocalPort and LocalIP properties and then invoke Listen method to listen for UDP data
' use Disconnect method to stop listening for UDP
' to change listening port or IP for UDP while listening, just change LocalPort and LocalIP properties. you do not have to Disconnect and then Listen again
' if LineSeparator property is not set, the DataArrival event will fire instead of the LineDataArrival event.  this allows you to receive binary data for example in a file transfer
' most functions/methods/properties of the CSocket object should be self-explanatory or easy to figure out if they are not documented here.
' if you are still unsure, look in the Object Browser (press F2) for vbWinsock to see descriptions of functions/methods/properties
' still stuck or you think there is a bug? e-mail me at aolsux@fall0ut.com
' *********************************************************

Option Explicit

Private WithEvents Socket As CSocket
Attribute Socket.VB_VarHelpID = -1
Public Users As Collection
Private Const ChatPort = 27492

Private Sub chkAuthorize_Click()
    SaveSetting "L33tChat", "Settings", "Authorize", CStr(chkAuthorize.Value)
End Sub

Private Sub cmdClear_Click()
    txtChat = ""
End Sub

Private Sub cmdClose_Click()
    Set Socket = Nothing
    Set Users = Nothing
    lstNames.Clear
    txtTalk.Locked = True
    ChangeButtonsState
End Sub

Private Sub cmdConnect_Click()
    Trim$ txtRemoteHost
    If txtRemoteHost = "" Then
        txtRemoteHost.SetFocus
        Beep
        Exit Sub
    End If
    Trim$ txtNickname
    If txtNickname = "" Or InStr(txtNickname, "@") Or InStr(txtNickname, " ") Then
        txtNickname.SetFocus
        Beep
        Exit Sub
    End If
    ChangeButtonsState
    Set Socket = New CSocket
    Socket.LineSeparator = vbCrLf
    Socket.Connect txtRemoteHost, ChatPort
End Sub

Private Sub cmdHost_Click()
    Trim$ txtNickname
    If txtNickname = "" Or InStr(txtNickname, "@") Or InStr(txtNickname, " ") Then
        txtNickname.SetFocus
        Beep
        Exit Sub
    End If
    ChangeButtonsState
    Set Socket = New CSocket
    Socket.LineSeparator = vbCrLf
    Socket.LocalPort = ChatPort
    Socket.Listen
    lstNames.AddItem "@" & txtNickname
    Set Users = New Collection
End Sub

Private Sub Form_Load()
Dim IPs() As String
    ' Set Local IP
    Set Socket = New CSocket
    Socket.GetIPs Socket.LocalHostName, IPs
    ' Socket.GetHosts can be used in this same way to retrieve host aliases for a machine in a string array
    Set Socket = Nothing
    txtLocalIP = IPs(1)
    txtNickname = GetSetting("L33tChat", "Info", "Nickname")
    chkAuthorize = Val(GetSetting("L33tChat", "Settings", "Authorize"))
    Form_Resize ' Resize Controls
    Subclass
End Sub

Private Sub Form_Resize()
    If Me.WindowState = vbMinimized Then Exit Sub
    txtTalk.Top = Me.ScaleHeight - 345
    cmdClear.Top = txtTalk.Top
    txtChat.Height = txtTalk.Top - 345
    lstNames.Height = txtChat.Height
    txtChat.Width = Me.Width - 3585
    txtTalk.Width = txtChat.Width
    lstNames.Left = txtChat.Width + 1635
    cmdClear.Left = lstNames.Left + 270
End Sub

Private Sub ChangeButtonsState()
Dim Enabled As Boolean
    Enabled = Not cmdConnect.Enabled
    cmdConnect.Enabled = Enabled
    txtRemoteHost.Locked = Not Enabled
    cmdHost.Enabled = Enabled
    txtNickname.Locked = Not Enabled
    cmdClose.Enabled = Not Enabled
End Sub

Private Sub Form_Unload(Cancel As Integer)
    UnSubClass
End Sub

Private Sub lstNames_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
Dim Nickname As String
    If Button = vbRightButton And lstNames.ListIndex > -1 Then
        Nickname = lstNames.List(lstNames.ListIndex)
        If Left$(Nickname, 1) = "@" Then Nickname = Mid$(Nickname, 2)
        If Socket.State = sockListening And Nickname <> txtNickname Then
            mnuKick.Visible = True
        Else
            mnuKick.Visible = False
        End If
        Me.PopupMenu mnuNicknames
    End If
End Sub

Private Sub mnuCopyIP_Click()
Dim Nickname As String
    Nickname = lstNames.List(lstNames.ListIndex)
    If Left$(Nickname, 1) = "@" Then Nickname = Mid$(Nickname, 2)
    If Nickname = txtNickname Then
        Clipboard.SetText txtLocalIP
    Else
        Clipboard.SetText GetUser(Nickname).RemoteHostIP
    End If
End Sub

Private Sub mnuKick_Click()
    GetUser(lstNames.List(lstNames.ListIndex)).Socket_Closed
End Sub

Private Sub Socket_Closed()
    cmdClose_Click
End Sub

Private Sub Socket_Connect()
    Set Users = New Collection
    Socket.SendData "C " & txtNickname
End Sub

Private Sub Socket_ConnectionRequest()
Dim User As CUser
    Set User = New CUser
    User.Socket.LineSeparator = vbCrLf
    User.Socket.Accept Socket
    User.Handle = User.Socket.Handle
    User.RemoteHostIP = User.Socket.RemoteHostIP
    Users.Add User, CStr(User.Handle)
End Sub

Private Sub Socket_Error(Error As Long, Description As String)
    Set Socket = Nothing
    ChangeButtonsState
    MsgBox "Error #" & Error & ":" & vbCrLf & Description, vbOKOnly, "Connection Error"
End Sub

Private Sub Socket_LineDataArrival(LineData As String, RemoteHostIP As String)
Dim Comnd As String
Dim Data As String
Dim Nickname As String
Dim User As CUser
    Comnd = Left$(LineData, InStr(LineData, " ") - 1)
    Data = Mid$(LineData, Len(Comnd) + 2)
    Select Case Comnd
        Case "A" ' No Authorization
            cmdClose_Click
            MsgBox "You have not been authorized to connect.", vbOKOnly, "No Authorization"
        Case "N" ' Nickname in use
            cmdClose_Click
            MsgBox "Nickname is already in use.", vbOKOnly, "Nickname in use"
        Case "SJ" ' Join
            If Users.Count = 0 Then
                ' First Join, Host
                Comnd = Data
                Data = Socket.RemoteHostIP
                txtTalk.Locked = False
            Else
                Comnd = Left$(Data, InStr(Data, " ") - 1)
                Data = Mid$(Data, Len(Comnd) + 2)
            End If
            Set User = New CUser
            If Left$(Comnd, 1) = "@" Then
                User.Nickname = Mid$(Comnd, 2)
            Else
                User.Nickname = Comnd
            End If
            User.RemoteHostIP = Data
            Users.Add User, User.Nickname
            If Users.Count = 1 Then
                ' Add me
                Socket_LineDataArrival "SJ " & txtNickname & " " & Socket.LocalIP, Socket.RemoteHostIP
            End If
            lstNames.AddItem Comnd
        Case "J"
            Comnd = Left$(Data, InStr(Data, " ") - 1)
            Data = Mid$(Data, Len(Comnd) + 2)
            Set User = New CUser
            User.Nickname = Comnd
            User.RemoteHostIP = Data
            Users.Add User, User.Nickname
            lstNames.AddItem Comnd
            If txtChat <> "" Then txtChat = txtChat & vbCrLf
            txtChat = txtChat & "* " & User.Nickname & " (" & Data & ") has joined the chat"
            txtChat.SelStart = Len(txtChat)
        Case "Q" ' Quit
            If txtChat <> "" Then txtChat = txtChat & vbCrLf
            txtChat = txtChat & "* " & Data & " (" & Users(Data).RemoteHostIP & ") has left the chat"
            txtChat.SelStart = Len(txtChat)
            Users.Remove Data
            lstNames.RemoveItem GetItemNum(Data)
        Case "T" ' Talk
            Comnd = Left$(Data, InStr(Data, " ") - 1)
            Data = Mid$(Data, Len(Comnd) + 2)
            If txtChat <> "" Then txtChat = txtChat & vbCrLf
            If LCase$(Left$(Data, 4)) = "/me " Then
                ' Action
                txtChat = txtChat & "* " & Comnd & Mid$(Data, 4)
            Else
                ' Statement
                txtChat = txtChat & "<" & Comnd & "> " & Data
            End If
            txtChat.SelStart = Len(txtChat)
    End Select
End Sub

Private Sub txtNickname_Change()
    SaveSetting "L33tChat", "Info", "Nickname", txtNickname
End Sub

Private Sub txtNickname_KeyPress(KeyAscii As Integer)
    If KeyAscii = 64 Then KeyAscii = 0 ' @
End Sub

Private Sub txtRemoteHost_KeyPress(KeyAscii As Integer)
    If KeyAscii = vbKeyReturn Then
        KeyAscii = 0
        cmdConnect_Click
    End If
End Sub

Private Sub txtTalk_KeyPress(KeyAscii As Integer)
Dim User As CUser
    If KeyAscii = vbKeyReturn And Trim$(txtTalk) <> "" Then ' Enter Key
        KeyAscii = 0
        If Socket.State = sockListening Then
            ' Host
            ' Send to all other users
            For Each User In Users
                If User.Nickname <> "" Then
                    User.Socket.SendData "T " & txtNickname & " " & txtTalk
                End If
            Next
        Else
            ' Client
            ' Send to host
            Socket.SendData "T " & txtTalk
        End If
        If txtChat <> "" Then txtChat = txtChat & vbCrLf
        If LCase$(Left$(txtTalk, 4)) = "/me " Then
            ' Action
            txtChat = txtChat & "* " & txtNickname & Mid$(txtTalk, 4)
        Else
            ' Statement
            txtChat = txtChat & "<" & txtNickname & "> " & txtTalk
        End If
        txtChat.SelStart = Len(txtChat)
        txtTalk = ""
    End If
End Sub
